//
//  ActivityIndicatorCollectionViewCell.swift
//  LiveLikeGiphyChallenge
//
//  Created by Arbnor Tefiki on 6.2.22.
//

import UIKit

class ActivityIndicatorCollectionViewCell: UICollectionViewCell {

  lazy var spinner = UIActivityIndicatorView(style: .large)

  override init(frame: CGRect) {
    super.init(frame: frame)
    commonInit()
  }

  required init?(coder: NSCoder) {
    super.init(coder: coder)
    commonInit()
  }

  private func commonInit() {
    spinner.translatesAutoresizingMaskIntoConstraints = false
    contentView.addSubview(spinner)
    spinner.centerXAnchor.constraint(equalTo: contentView.centerXAnchor).isActive = true
    spinner.centerYAnchor.constraint(equalTo: contentView.centerYAnchor).isActive = true
  }
}

